#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

int
main(int argc, char *argv[])
{
	char buf[1024];
	struct ifconf ifc;
	struct ifreq *ifr;
	int i, fd, n, res;

	fd = socket(AF_INET, SOCK_DGRAM, 0);

	if (fd == -1) {
		fprintf(stderr, "can't create socket: %s\n", strerror(errno));
		exit(1);
	}

	ifc.ifc_len = sizeof(buf);
	ifc.ifc_buf = buf;

	res = ioctl(fd, SIOCGIFCONF, &ifc);

	if (res == -1) {
		fprintf(stderr, "ioctl() SIOCGIFCONF: %s\n", strerror(errno));
		exit(1);
	}

	ifr = ifc.ifc_req;
	n = ifc.ifc_len / sizeof(struct ifreq);

	for (i = 0; i < (ifc.ifc_len / sizeof(*ifr)); i++) {
		struct ifreq *iter = ifr + i;
		struct sockaddr_in *sa = (struct sockaddr_in *)(&iter->ifr_addr);
		printf("name=%s IP=%s\n", iter->ifr_name, inet_ntoa(sa->sin_addr));
	}

	return 0;
}
